import cv2
import numpy as np

cv2.namedWindow('img', cv2.WINDOW_NORMAL | cv2.WINDOW_KEEPRATIO)

# Read image
image = cv2.imread('pic/1.png')

# Convert image to grayscale
gray = cv2.cvtColor(image,cv2.COLOR_BGR2GRAY)

# Use canny edge detection
edges = cv2.Canny(gray,100,150,apertureSize=3)

# Apply HoughLinesP method to 
# to directly obtain line end points
lines_list =[]
lines = cv2.HoughLinesP(
            edges, # Input edge image
            1, # Distance resolution in pixels
            np.pi/180, # Angle resolution in radians
            threshold=100, # Min number of votes for valid line
            minLineLength=250, # Min allowed length of line
            maxLineGap=1 # Max allowed gap between line for joining them
            )

for line in lines:
    for x1, y1, x2, y2 in line:
      #if x1 == x2 or y1 == y2:
        print(x1,x2,y1,y2)
        cv2.line(image, (x1, y1), (x2, y2), (0, 255, 0), 2)
'''
# Iterate over points
for points in lines:
      # Extracted points nested in the list
    x1,y1,x2,y2=points[0]
    # Draw the lines joing the points
    # On the original image
    cv2.line(image,(x1,y1),(x2,y2),(0,255,0),2)
    # Maintain a simples lookup list for points
    lines_list.append([(x1,y1),(x2,y2)])
'''

# Save the result image
#cv2.imwrite('detectedLines.png',image)
#cv2.imshow("image", gray) ##显示灰度图
#cv2.imshow("image", edges) ##显示canny图
cv2.imshow('img', image)
cv2.waitKey(0)
